#pragma once
#include "stdafx.h"
#include <vector>
#include <deque>
#include <stack>
#include <algorithm>
#include <functional>
#include "cmath"
#include <fstream> 
#include <string>
#include "locale.h"
#include "iostream"
using namespace std;
typedef struct date
{
	int day;
	int month;
	int year;
} date;
typedef struct Record
{
	int nomer;
	string name;
	string rayon;
	string address;
	int telefon;
	int oplata;
	int abonplata;
	date dateofdogovor;
	date datelastpay;
} record;

//void record_tofile(record r, ofsream out);
void print_record(Record r);
bool namecomp(const record &a, const record &b) ;
bool namecmp(const record& a, string value);
bool rayoncomp(const record &a, const record &b) ;
bool rayoncmp(const record& a, string value);
bool datedcomp(const record &a, const record &b) ;
bool datedcmp(const record& a, date value);
bool datelpcomp(const record &a, const record &b) ;
bool datelpcmp(const record& a, date value);
class abonent
{
public:

	typedef vector<record> vect;
	vect v;

	typedef deque<record> deq;
	abonent(void);
	~abonent(void);

	void add_v()
	{
		record r;
		cout<<"\n : ";
		cin>>r.nomer;
		cout<<"\n : ";
		cin>>r.name;
		cout<<"\n : ";
		cin>>r.rayon;
		cout<<"\n : ";
		cin>>r.address;
		cout<<"\n : ";
		cin>>r.telefon;
		cout<<"\n  : ";
		cin>>r.oplata;
		cout<<"\n  : ";
		cin>>r.abonplata;
		cout<<"\n   (-): ";
		cin>>r.dateofdogovor.day>>r.dateofdogovor.month>>r.dateofdogovor.year;
		cout<<"\n    (-): ";
		cin>>r.datelastpay.day>>r.datelastpay.month>>r.datelastpay.year;
		v.insert(v.end(), r);
		cout<<"!"<<endl;
	}

	void print_v()
	{
		vect::iterator it;
		cout<<"\t\t\t\t\t\t\t \t  "<<endl;
		for(it=v.begin();it!=v.end();it++) print_record(*it);
	}
	void delete_v()
	{
		int i;
		cout<<"   ,   : ";
		cin>>i;
		vect::iterator it;
		it=v.begin();
		while ((*it).nomer!=i && it!=v.end()) it++; 
		if (it!=v.end())
		{
			v.erase(it);
			cout<<"!"<<endl;
		}
		else cout<<"  !"<<endl;

	}
	void zamena_v()
	{
		int i;
		cout<<"   ,     : ";
		cin>>i;
		vect::iterator it;
		it=v.begin();
		while ((*it).nomer!=i && it!=v.end()) it++; 
		if (it!=v.end())
		{
			v.erase(it);
			add_v();
		}
		else cout<<"  !"<<endl;
	}
	void poisk_v()
	{
		deq results;
		vect::iterator it1;
		deq::reverse_iterator it2r;
		it1=v.begin();
		//it2=results.begin();		
		int choise,type;
		do
		{
			cout << "  :\n1.\n2.\n3.  \n4.  \n";
			cin >> choise;
		} while (choise<1 || choise>4);
		do
		{
			cout << "  :\n1.\n2.\n";
			cin >> type;
		} while (type<1 || type>2);
		cout << " :";
		switch(type)
		{
		case 1:
			{
				switch(choise)
				{
				case 1: 
					{
						string strquery;
						cin >> strquery;
						while (it1!=v.end()) 
						{
						if ((*it1).name==strquery)
							results.push_back(*it1);
						it1++;
						}
					} break;
				case 2: 
					{
						string strquery;
						cin >> strquery;
						while (it1!=v.end()) 
						{
						if ((*it1).rayon==strquery) results.push_back(*it1);
						it1++;
						}
					} break;
				case 3:
					{
						date datequery;
						cin>>datequery.day>>datequery.month>>datequery.year;
						while (it1!=v.end()) 
						{
							if ((*it1).dateofdogovor.day==datequery.day &&
								(*it1).dateofdogovor.month==datequery.month &&
								(*it1).dateofdogovor.year==datequery.year) results.push_back(*it1);
						it1++;
						}
					} break;
				case 4: 
					{
						date datequery;
						cin>>datequery.day>>datequery.month>>datequery.year;
						while (it1!=v.end()) 
						{
							if ((*it1).datelastpay.day==datequery.day &&
								(*it1).datelastpay.month==datequery.month &&
								(*it1).datelastpay.year==datequery.year) results.push_back(*it1);
						it1++;
						}
					} break;
				}
				
			} break;
		case 2:
			{
				switch(choise)
				{
				case 1: 
					{
						string strquery;
						cin >> strquery;
						sort(v.begin(),v.end(),namecomp);
						it1 = lower_bound(v.begin(),v.end(),strquery,namecmp);
						results.push_back(*it1);
					} break;
				case 2: 
					{
						string strquery;
						cin >> strquery;
						sort(v.begin(),v.end(),rayoncomp);
						it1 = lower_bound(v.begin(),v.end(),strquery,rayoncmp);
						results.push_back(*it1);
					} break;
				case 3: 
					{
						date datequery;
						cin>>datequery.day>>datequery.month>>datequery.year;
						sort(v.begin(),v.end(),datedcomp);
						it1 = lower_bound(v.begin(),v.end(),datequery,datedcmp);
						while ((*it1).dateofdogovor.day==datequery.day &&
								(*it1).dateofdogovor.month==datequery.month &&
								(*it1).dateofdogovor.year==datequery.year) 
						{
							results.push_back(*it1);
							it1++;
						}
					} break;
				case 4: 
					{
						date datequery;
						cin>>datequery.day>>datequery.month>>datequery.year;
						sort(v.begin(),v.end(),datelpcomp);
						it1 = lower_bound(v.begin(),v.end(),datequery,datelpcmp);
						while ((*it1).datelastpay.day==datequery.day &&
								(*it1).datelastpay.month==datequery.month &&
								(*it1).datelastpay.year==datequery.year) 
						{
							results.push_back(*it1);
							it1++;
						}
					} break;
				} 
			} break;
		}
		if (results.empty()) cout<<"  !\n";
		else
		{
		ofstream out;
		out.open("output.txt");
		stack<record> st;
		out<<"\t\t\t\t\t\t\t \t  "<<endl;
		while (!results.empty())
		{	
			record rec=results.front();
			results.pop_front();
			st.push(rec);
			//record_tofile(*it2,out);
			out<<rec.nomer<<"\t"<<rec.name<<"\t"<<rec.rayon<<"\t"<<rec.address<<"\t"
			<<rec.telefon<<"\t"<<rec.oplata<<"\t"<<rec.abonplata<<"\t\t"<<rec.dateofdogovor.day
			<<"."<<rec.dateofdogovor.month<<"."<<rec.dateofdogovor.year<<"\t\t"<<rec.datelastpay.day<<
			"."<<rec.datelastpay.month<<"."<<rec.datelastpay.year<<endl;
		}
		out.close();
		out.open("output_reverce.txt");
		out<<"\t\t\t\t\t\t\t \t  "<<endl;
		while (!st.empty())
		{
			record rec=st.top();
			st.pop();
			out<<rec.nomer<<"\t"<<rec.name<<"\t"<<rec.rayon<<"\t"<<rec.address<<"\t"
			<<rec.telefon<<"\t"<<rec.oplata<<"\t"<<rec.abonplata<<"\t\t"<<rec.dateofdogovor.day
			<<"."<<rec.dateofdogovor.month<<"."<<rec.dateofdogovor.year<<"\t\t"<<rec.datelastpay.day<<
			"."<<rec.datelastpay.month<<"."<<rec.datelastpay.year<<endl;
		}
		out.close();
		cout<<"!\n";
		}
	}
};

